// $Id: J4AttMFieldMap.hh,v 1.1.1.1 2002/05/02 07:56:58 hoshina Exp $
#ifndef __J4ATTMFIELDMAP__
#define __J4ATTMFIELDMAP__
//*************************************************************************
//* --------------------
//* J4AttMFieldMap
//* --------------------
//* (Description)
//* 	This class applies the attribute for magnetic field.
//*     Mother class : None
//*    
//* (Update Record)
//*	2002/09/13  T.Aso	Original version.
//*************************************************************************
 
#include "globals.hh"
#include "J4MagneticField.hh"
#include "J4VComponent.hh"
// ====================================================================
// -----------------------
// class definition
// -----------------------

class J4AttMFieldMap{

public:
  J4AttMFieldMap();
  ~J4AttMFieldMap();

  void SetMField(J4MagneticField* mfield) { fmfield = mfield; };

  void InstallMField(J4VComponent* component);

  G4bool IsMValid(const G4double Point[3]);

  void GetMFieldValue(const G4double Point[3], 
			     G4double* Bfield, G4bool& onlyFlag );  

  G4String* GetMFieldName() { return fMFname; };

private:
  void DefineGlobalMValidBox();

private:
  G4String* fMFname;
  J4MagneticField* fmfield;
  G4ThreeVector fTrans;
  G4RotationMatrix fRot;
  G4RotationMatrix fRotInverse;
  G4bool fIsOrigin;

  G4double fMValidX[2];
  G4double fMValidY[2];
  G4double fMValidZ[2];

};

#endif


