// $Id: J4MagneticFieldManager.cc,v 1.1.1.1 2002/05/02 07:56:58 hoshina Exp $
//*************************************************************************
//* --------------------
//* J4MagneticFieldManager
//* --------------------
//* (Description)
//* 	This class applies magnetic field.
//*     Mother class : J4VDetectorComponent
//*    
//* (Update Record)
//*	2001/02/18  K.Hoshina	Original version.
//*************************************************************************
 
#include "J4MagneticFieldManager.hh"

J4MagneticFieldManager* J4MagneticFieldManager::fpInstance=0;

//=====================================================================
//---------------------
// class description
//---------------------
J4MagneticFieldManager::J4MagneticFieldManager()
:G4MagneticField(),fcurCount(0){
  fmagCollection  = new J4AttMFieldMap* [100]; 
}

void J4MagneticFieldManager::GetFieldValue(const  G4double Point[3], 
				           G4double* Bfield ) const
{

  Bfield[0] = 0.;
  Bfield[1] = 0.;
  Bfield[2] = 0.;

  G4double bfc[3]; 
  G4bool onlyFlag;
  for ( int i = 0; i < fcurCount; i++){
    if ( fmagCollection[i]&&fmagCollection[i]->IsMValid(Point) ){
      fmagCollection[i]->GetMFieldValue(Point,bfc,onlyFlag);
      //G4cout << " End of GetMFieldValue " 
      //	   << bfc[0]/tesla << " " 
      //	   << bfc[1]/tesla << " " 
      //	   << bfc[2]/tesla << " " << i << G4endl;
      if ( onlyFlag == true ){
	Bfield[0] = bfc[0];
	Bfield[1] = bfc[1];  
	Bfield[2] = bfc[2]; 
	break;
      }else{
	Bfield[0] += bfc[0];
	Bfield[1] += bfc[1];  
	Bfield[2] += bfc[2]; 
      }
    }
  }

#if 0
  if ( Bfield[0] != 0 || Bfield[1] !=0 || Bfield[2] !=0 ){
    G4cout << "Bfield " << Bfield[0]/tesla
	 << " "       << Bfield[1]/tesla 
	 << " "       << Bfield[2]/tesla 
	 << "Position " << Point[0]/m
	 << " "       << Point[1]/m 
	 << " "       << Point[2]/m << G4endl;
  }
#endif
}


