// $Id: J4Solenoid.hh,v 1.3 2002/05/28 09:27:19 hoshina Exp $
#ifndef __J4SOLENOIDE__
#define __J4SOLENOIDE__
//*************************************************************************
//* --------------------
//* J4Solenoide
//* --------------------
//* (Description)
//* 	Derivation class for Solenoid.
//*     Mother class : J4VDetectorComponent
//*     Mother class : J4ATTMFieldMap
//*    
//* (Update Record)
//*	2002/09/13  T.Aso	Original version.
//*************************************************************************

#include "J4VSOLDetectorComponent.hh"
#include "J4SOLParameter.hh"
#include "J4ATTMFieldMap.hh"
#include "J4SolenoidMField.hh"

//=====================================================================
//---------------------
// class definition
//---------------------

class J4Solenoid : public J4VSOLDetectorComponent, public J4ATTMFieldMap  {

public:
  J4Solenoid(J4VDetectorComponent *parent = 0,
                       G4int  nclones   = 1,
                       G4int  nbrothers = 1, 
                       G4int  me        = 0,
                       G4int  copyno    = -1 );
  virtual ~J4Solenoid();

  virtual void  InstallIn(J4VComponent         *mother,
                          G4RotationMatrix     *prot  = 0,
                          const G4ThreeVector  &tlate = 0 );
  virtual void	Draw()      ;
  virtual void	Print() const ;
  
private:
  void 	Assemble();    
  void  Cabling ();
  
private:  
  static G4String	fFirstName;
};

#endif


