// $Id: J4Solenoid.cc,v 1.5 2002/06/23 01:45:08 hoshina Exp $
//*************************************************************************
//* --------------------
//* J4Solenoid
//* --------------------
//* (Description)
//* 	Class for describing his/her detector compornents.
//*     
//* (Update Record)
//*	2002/09/13  T.Aso	Original version.
//*************************************************************************

#include "J4Solenoid.hh"

// ====================================================================
//--------------------------------
// constants (detector parameters)
//--------------------------------

G4String J4Solenoid::fFirstName("Solenoid");

//=====================================================================
//---------------------
// Class Description
//---------------------

//=====================================================================
//* constructor -------------------------------------------------------

J4Solenoid::J4Solenoid(J4VDetectorComponent *parent,
                            G4int  nclones,
                            G4int  nbrothers, 
                            G4int  me,
                            G4int  copyno ) :
       J4VSOLDetectorComponent(fFirstName, parent, nclones,
				    nbrothers, me, copyno),
	      J4ATTMFieldMap()
{   
}

//=====================================================================
//* destructor --------------------------------------------------------
J4Solenoid::~J4Solenoid()
{
}

//=====================================================================
//* Assemble   --------------------------------------------------------
void J4Solenoid::Assemble() 
{   
  if(!GetLV()){

    G4String name( GetName() );
    G4VSolid *tube = new G4Tubs( name,291.*cm,
				   350.*cm,
                                     320.*cm, 0, 2*M_PI);  

    Register(tube);
    SetSolid(tube);
                                       
    // MakeLogicalVolume --//  
    MakeLVWith(OpenMaterialStore()->Order(_SOLENOIDMAT_));
    
    // SetVisAttribute ----//
    PaintLV(TRUE, G4Color(1, 0, 0));
  	
    // Install daughter PV //
    // Magnetic field
    J4SolenoidMField*   mfield = new J4SolenoidMField();
    SetMField(mfield);
  }
      
}

//=====================================================================
//* Cabling  ----------------------------------------------------------
void J4Solenoid::Cabling()
{
}

//=====================================================================
//* InstallIn  --------------------------------------------------------
void J4Solenoid::InstallIn(J4VComponent         *mother,
                      G4RotationMatrix     *prot, 
                      const G4ThreeVector  &tlate )
{ 
  Assemble();			// You MUST call Assemble(); at first.
  				// 
  
  // Placement function into mother object...
  SetPVPlacement();
  InstallMField(this);
}


//* Draw  --------------------------------------------------------
void J4Solenoid::Draw()
{
  // set visualization attributes
  
}
	
//* Print  --------------------------------------------------------
void J4Solenoid::Print() const
{
}

	
	


